exercise_04_27: exercise_04_27.o | .gitignore
	g++ $^ -o $@ 

exercise_04_27.ii: exercise_04_27.cpp
	g++ -E $^ -o $@

exercise_04_27.s: exercise_04_27.ii
	g++ -S $^ -o $@

exercise_04_27.o: exercise_04_27.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_04_27" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_04_27 .gitignore debug

test: exercise_04_27 
	./exercise_04_27 < test.in > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

test1: exercise_04_27 
	./exercise_04_27 < test1.in > test1.out
	diff test1.out test1.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_27.ii exercise_04_27.s
.SECONDARY: exercise_04_27.ii exercise_04_27.s

dbg: debug/exercise_04_27 

debug/exercise_04_27: debug/exercise_04_27.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_27.o: debug/exercise_04_27.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_27.s: debug/exercise_04_27.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_27.ii: exercise_04_27.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

